diff -NarU2 a/contrib/plugins/graft-thumbs.js b/contrib/plugins/graft-thumbs.js
--- a/contrib/plugins/graft-thumbs.js	2026-07-08 15:13:32.813795232 +0000
+++ b/contrib/plugins/graft-thumbs.js	2026-07-08 15:11:40.605178933 +0000
@@ -83,13 +83,13 @@
 
 	// ...and then the trick! near the end of loadgrid,
-	// thegrid.bagit is called to initialize the baguettebox
+	// msel.bagit is called to initialize the baguettebox
 	// (image/video gallery); this is the perfect function to
 	// "hook" (hijack) so we can run our code :^)
 
 	// need to grab a backup of the original function first,
-	var orig_func = thegrid.bagit;
+	var orig_func = msel.bagit;
 
 	// and then replace it with our own:
-	thegrid.bagit = function (isrc) {
+	msel.bagit = function (isrc) {
 
 		if (isrc !== '#ggrid')
@@ -105,5 +105,5 @@
 		setTimeout(graft_thumbs, 1);
 
-		// and finally, call the original thegrid.bagit function
+		// and finally, call the original msel.bagit function
 		return orig_func(isrc);
 	};
diff -NarU2 a/contrib/plugins/minimal-up2k.js b/contrib/plugins/minimal-up2k.js
--- a/contrib/plugins/minimal-up2k.js	2026-07-08 15:13:32.813795232 +0000
+++ b/contrib/plugins/minimal-up2k.js	2026-07-08 15:11:40.605178933 +0000
@@ -40,18 +40,4 @@
 }
 #u2conf {margin:5em auto 0 auto !important}
-#u2conf.ww {width:70em}
-#u2conf.w {width:50em}
-#u2conf.w .c,
-#u2conf.w #u2btn_cw {text-align:left}
-#u2conf.w #u2btn_cw {width:70%}
-#u2etaw {margin:3em auto}
-#u2etaw.w {
-  text-align: center;
-  margin: -3.5em auto 5em auto;
-}
-#u2etaw.w #u2etas {margin-right:-37em}
-#u2etaw.w #u2etas.o {margin-top:-2.2em}
-#u2etaw.ww {margin:-1em auto}
-#u2etaw.ww #u2etas {padding-left:4em}
 #u2etas {
   background: none !important;
diff -NarU2 a/contrib/plugins/rave.js b/contrib/plugins/rave.js
--- a/contrib/plugins/rave.js	2026-07-08 15:13:32.813795232 +0000
+++ b/contrib/plugins/rave.js	2026-05-22 21:41:25.288307384 +0000
@@ -120,5 +120,5 @@
             document.body.style.marginLeft = hrand() * uofs + 'px';
             ebi('tree').style.marginLeft = hrand() * uofs + 'px';
-            for (var a of QSA('#ops>a, #path>a, #pctl>a'))
+            for (var a of QSA('#ops>a, #path>a, .pctl>a'))
                 a.style.transform = 'translate(' + hrand() * uofs * 1 + 'px, ' + hrand() * uofs * 0.7 + 'px) rotate(' + Math.random() * uofs * 0.7 + 'deg)'
         }
diff -NarU2 a/copyparty/authsrv.py b/copyparty/authsrv.py
--- a/copyparty/authsrv.py	2026-07-28 23:16:17.534485289 +0000
+++ b/copyparty/authsrv.py	2026-07-28 23:14:14.881200160 +0000
@@ -3260,4 +3260,10 @@
                 continue  # propagates later in this func
             vf = vn.flags
+            if "theme" in vf:
+                if re.match(r'[0-9]', vf["theme"]):
+                    zs = int(vf["theme"])
+                    bri = "zy"[zs % 2 :][:1]
+                    ch = "abcdefghijklmnopqrstuvwx"[int(zs / 2)]
+                    vf["theme"] = "{0}{1} {0} {1}".format(ch, bri)
             vn.js_ls = {
                 "idx": "e2d" in vf,
@@ -3278,4 +3284,7 @@
                 "sb_md": "" if "no_sb_md" in vf else (vf.get("md_sbf") or "y"),
                 "rw_edit": vf["rw_edit"],
+                "dtheme": vf["theme"],
+                "bg_img": vf["bg_img"],
+                "tcolor": vf["tcolor"],
             }
             if "ufavico_h" in vf:
@@ -3304,4 +3313,7 @@
                 "sba_lg": vf.get("lg_sba") or "",
                 "rw_edit": vf["rw_edit"],
+                "dtheme": vf["theme"],
+                "bg_img": vf["bg_img"],
+                "tcolor": vf["tcolor"],
                 "txt_ext": self.args.textfiles.replace(",", " "),
                 "def_hcols": list(vf.get("mth") or []),
diff -NarU2 a/copyparty/cfg.py b/copyparty/cfg.py
--- a/copyparty/cfg.py	2026-07-28 23:16:17.534485289 +0000
+++ b/copyparty/cfg.py	2026-07-28 23:14:14.881707228 +0000
@@ -104,4 +104,5 @@
     for k in (
         "apnd_who",
+        "bg_img",
         "bup_ck",
         "cachectl",
@@ -114,4 +115,5 @@
         "db_xattr",
         "du_who",
+        "theme",
         "epilogues",
         "ufavico",
@@ -307,6 +309,6 @@
     },
     'database, audio tags\n"mte", "mth", "mtp", "mtm" all work the same as -mte, -mth, ...': {
-        "mte=artist,title": "media-tags to index/display",
-        "mth=fmt,res,ac": "media-tags to hide by default",
+        "mte=artist,title": "media-tags/file-columns to index/display",
+        "mth=fmt,res,ac": "media-tags/file-columns to hide by default",
         "mtp=.bpm=f,audio-bpm.py": 'uses the "audio-bpm.py" program to\ngenerate ".bpm" tags from uploads (f = overwrite tags)',
         "mtp=ahash,vhash=media-hash.py": "collects two tags at once",
@@ -349,4 +351,6 @@
     "client and ux": {
         "grid": "show grid/thumbnails by default",
+        "bg_img": "set a background image",
+        "theme": "set a default theme",
         "gsel": "select files in grid by ctrl-click",
         "sort": "default sort order",
diff -NarU2 a/copyparty/httpcli.py b/copyparty/httpcli.py
--- a/copyparty/httpcli.py	2026-07-28 23:16:17.536485324 +0000
+++ b/copyparty/httpcli.py	2026-07-28 23:14:14.882573726 +0000
@@ -367,4 +367,5 @@
         self.out_headers = {
             "Cache-Control": "no-store, max-age=0",
+            "Service-Worker-Allowed": "/",
         }
 
@@ -1553,4 +1554,7 @@
                 return self.tx_svcs()
 
+            if "config" in self.uparam:
+                return self.tx_config()
+
             if "shares" in self.uparam:
                 return self.tx_shares()
@@ -5537,5 +5541,5 @@
         # so url-param "raster" returns a png/webp instead
         # (useragent-sniffing kinshi due to caching proxies)
-        mime, ico = self.conn.hsrv.ico.get(txt, not small, "raster" in self.uparam)
+        mime, ico = self.conn.hsrv.ico.get(txt, not small, "raster" in self.uparam, self.uparam.get('a'))
 
         lm = formatdate(self.E.t0)
@@ -5684,4 +5688,15 @@
         return True
 
+    def tx_config(self) -> bool:
+        html = self.j2s(
+            "config",
+            this=self,
+            accs=bool(self.asrv.acct),
+            s="s" if self.is_https else "",
+            bg_img=self.args.bg_img,
+        )
+        self.reply(html.encode("utf-8"))
+        return True
+
     def tx_svcs(self) -> bool:
         aname = re.sub("[^0-9a-zA-Z]+", "", self.args.vname) or "a"
@@ -6897,5 +6912,5 @@
                 "lead": "",
                 "href": "%s/" % (x,),
-                "ext": "---",
+                "ext": "",
                 "sz": 0,
                 "ts": 0,
@@ -7107,5 +7122,5 @@
 
                     if is_dir:
-                        return self.tx_svg("folder")
+                        return self.reply(b"(no thumbnail)")
 
                 thp = None
@@ -7127,5 +7142,5 @@
                     raise Pebkac(415)
 
-                return self.tx_ico(rem)
+                return self.reply(b"(no thumbnail)")
 
         elif self.can_write and th_fmt is not None:
@@ -7231,4 +7246,5 @@
 
         zi = vn.flags["du_iwho"]
+        volspace = []
         if zi and (
             zi == 9
@@ -7255,7 +7271,10 @@
                         except:
                             pass
-                h1 = humansize(free or 0)
+                if not free:
+                    free = 0
+                h1 = humansize(free)
                 h2 = humansize(total)
                 srv_info.append("{} free of {}".format(h1, h2))
+                volspace = [h1, h2, int((total - free) / total * 10000)]
             elif zs:
                 self.log("diskfree(%r): %s" % (abspath, zs), 3)
@@ -7308,4 +7327,5 @@
             "taglist": [],
             "srvinf": srv_infot,
+            "volspace": volspace,
             "acct": self.uname,
             "perms": perms,
@@ -7316,4 +7336,5 @@
             "acct": self.uname,
             "perms": perms,
+            "volspace": volspace,
         }
         # also see `js_htm` in authsrv.py
@@ -7331,5 +7352,8 @@
             "title": html_escape("%s %s" % (self.args.bname, self.vpath), crlf=True),
             "srv_info": srv_infot,
+            "srv_name": "" if self.args.nih else self.args.name,
+            "srv_url": self.args.name_url if self.args.name_url else "/",
             "dtheme": self.args.theme,
+            "unfun": self.args.unfun,
         }
 
@@ -7476,10 +7500,10 @@
                 elif add_dk:
                     zs = absreal(fspath)
-                    margin = '<a href="%s?k=%s&zip=crc" rel="nofollow">zip</a>' % (
+                    margin = '<a href="%s?k=%s&zip=crc" rel="nofollow" class="dir">zip</a>' % (
                         quotep(href),
                         self.gen_fk(2, self.args.dk_salt, zs, 0, 0)[:add_dk],
                     )
                 else:
-                    margin = '<a href="%s?zip=crc" rel="nofollow">zip</a>' % (
+                    margin = '<a href="%s?zip=crc" rel="nofollow" class="dir">zip</a>' % (
                         quotep(href),
                     )
@@ -7505,5 +7529,5 @@
 
             if is_dir:
-                ext = "---"
+                ext = ""
             elif "." in fn:
                 ext = ptn_hr.sub("@", fn.rsplit(".", 1)[1])
diff -NarU2 a/copyparty/httpsrv.py b/copyparty/httpsrv.py
--- a/copyparty/httpsrv.py	2026-07-28 23:16:17.536485324 +0000
+++ b/copyparty/httpsrv.py	2026-07-28 23:14:14.882763044 +0000
@@ -190,4 +190,5 @@
             "browser2",
             "cf",
+            "config",
             "idp",
             "md",
diff -NarU2 a/copyparty/ico.py b/copyparty/ico.py
--- a/copyparty/ico.py	2026-07-28 23:16:17.536485324 +0000
+++ b/copyparty/ico.py	2026-07-28 23:14:14.882839870 +0000
@@ -12,22 +12,17 @@
 
 
+RE_CSS_COLOR = re.compile(r"[^a-zA-Z0-9#()%.,/-]")
+
+
 class Ico(object):
     def __init__(self, args: argparse.Namespace) -> None:
         self.args = args
 
-    def get(self, ext: str, as_thumb: bool, chrome: bool) -> tuple[str, bytes]:
+    def get(self, ext: str, as_thumb: bool, png: bool, accent: str) -> tuple[str, bytes]:
         """placeholder to make thumbnails not break"""
 
         bext = ext.encode("ascii", "replace")
         ext = bext.decode("utf-8")
-        zb = hashlib.sha1(bext).digest()[2:4]
-        if PY2:
-            zb = [ord(x) for x in zb]  # type: ignore
-
-        c1 = colorsys.hsv_to_rgb(zb[0] / 256.0, 1, 0.3)
-        c2 = colorsys.hsv_to_rgb(zb[0] / 256.0, 0.8 if HAVE_PILF else 1, 1)
-        ci = [int(x * 255) for x in list(c1) + list(c2)]
-        c = "".join(["%02x" % (x,) for x in ci])
-
+        
         w = 100
         h = 30
@@ -36,5 +31,11 @@
             h = int(100.0 / (float(sw) / float(sh)))
 
-        if chrome:
+        if accent:
+            accent = RE_CSS_COLOR.sub("", accent)
+
+        # obsolete. 2000+ svgs slows chrome down massively, but no crash.
+        # further, unique svgs are only used for non-standard thumbnails,
+        # so it's unrealistic to see that many in use
+        if png & 0:
             # cannot handle more than ~2000 unique SVGs
             if HAVE_PILF:
@@ -49,9 +50,9 @@
                     h = int(128.0 * h / w)
                     w = 128
-                    img = Image.new("RGB", (w, h), "#" + c[:6])
+                    img = Image.new("RGBA", (w, h), "#00000000")
                     pb = ImageDraw.Draw(img)
                     _, _, tw, th = pb.textbbox((0, 0), ext2, font_size=16)
                     xy = (int((w - tw) / 2), int((h - th) / 2))
-                    pb.text(xy, ext2, fill="#" + c[6:], font_size=16)
+                    pb.text(xy, ext2, fill=accent, font_size=16)
 
                     img = img.resize((w * 2, h * 2), Image.NEAREST)
@@ -70,5 +71,5 @@
                 h = int(64.0 * h / w)
                 w = 64
-                img = Image.new("RGB", (w, h), "#" + c[:6])
+                img = Image.new("RGBA", (w, h), "#00000000")
                 pb = ImageDraw.Draw(img)
                 try:
@@ -80,5 +81,5 @@
                 cw = tw // len(ext)
                 x = ((w - tw) // 2) - (cw * 2) // 3
-                fill = "#" + c[6:]
+                fill = accent
                 for ch in ext:
                     pb.text((x, (h - th) // 2), " %s " % (ch,), fill=fill)
@@ -94,7 +95,7 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <svg version="1.1" viewBox="0 0 100 {}" xmlns="http://www.w3.org/2000/svg"><g>
-<rect width="100%" height="100%" fill="#{}" />
+<rect width="100%" height="100%" fill="#0000" />
 <text x="50%" y="{}" dominant-baseline="middle" text-anchor="middle" xml:space="preserve"
-  fill="#{}" font-family="monospace" font-size="14px" style="letter-spacing:.5px">{}</text>
+  fill="{}" font-family="monospace" font-size="14px" style="letter-spacing:.5px">{}</text>
 </g></svg>
 """
@@ -110,5 +111,5 @@
             y = "50%"
 
-        svg = svg.format(h, c[:6], y, c[6:], txt)
+        svg = svg.format(h, y, accent or '#000', txt)
 
         return "image/svg+xml", svg.encode("utf-8")
diff -NarU2 a/copyparty/__init__.py b/copyparty/__init__.py
--- a/copyparty/__init__.py	2026-07-28 23:16:17.533485272 +0000
+++ b/copyparty/__init__.py	2026-07-28 23:14:14.880319846 +0000
@@ -73,5 +73,9 @@
 web/browser2.html
 web/cf.html
+web/config.css
+web/config.html
+web/config.js
 web/copyparty.gif
+web/copyparty.svg
 web/deps/busy.mp3
 web/deps/easymde.css
@@ -90,4 +94,5 @@
 web/idp.html
 web/iiam.gif
+web/manifest.json
 web/md.css
 web/md.html
@@ -111,4 +116,5 @@
 web/svcs.html
 web/svcs.js
+web/sw.js
 web/tl/chi.js
 web/tl/cze.js
diff -NarU2 a/copyparty/__main__.py b/copyparty/__main__.py
--- a/copyparty/__main__.py	2026-07-28 23:16:17.533485272 +0000
+++ b/copyparty/__main__.py	2026-07-28 23:14:14.880755109 +0000
@@ -1922,6 +1922,6 @@
     ap2.add_argument("--db-xattr", metavar="t,t", type=u, default="", help="read file xattrs as metadata tags; [\033[32ma,b\033[0m] reads keys \033[33ma\033[0m and \033[33mb\033[0m as tags \033[33ma\033[0m and \033[33mb\033[0m, [\033[32ma=foo,b=bar\033[0m] reads keys \033[33ma\033[0m and \033[33mb\033[0m as tags \033[33mfoo\033[0m and \033[33mbar\033[0m, [\033[32m~~a,b\033[0m] does everything except \033[33ma\033[0m and \033[33mb\033[0m, [\033[32m~~\033[0m] does everything. NOTE: Each tag must also be enabled with \033[33m-mte\033[0m (volflag=db_xattr)")
     ap2.add_argument("-mtm", metavar="M=t,t,t", type=u, action="append", help="\033[34mREPEATABLE:\033[0m add/replace metadata mapping")
-    ap2.add_argument("-mte", metavar="M,M,M", type=u, help="tags to index/display (comma-sep.); either an entire replacement list, or add/remove stuff on the default-list with +foo or /bar", default=DEF_MTE)
-    ap2.add_argument("-mth", metavar="M,M,M", type=u, help="tags to hide by default (comma-sep.); assign/add/remove same as \033[33m-mte\033[0m", default=DEF_MTH)
+    ap2.add_argument("-mte", metavar="M,M,M", type=u, help="tags/file-columns to index/display (comma-sep.); either an entire replacement list, or add/remove stuff on the default-list with +foo or /bar", default=DEF_MTE)
+    ap2.add_argument("-mth", metavar="M,M,M", type=u, help="tags/file-columns to hide by default (comma-sep.); assign/add/remove same as \033[33m-mte\033[0m", default=DEF_MTH)
     ap2.add_argument("-mtp", metavar="M=[f,]BIN", type=u, action="append", help="\033[34mREPEATABLE:\033[0m read tag \033[33mM\033[0m using program \033[33mBIN\033[0m to parse the file")
     ap2.add_argument("--have-db-xattr", action="store_true", help=argparse.SUPPRESS)
@@ -1963,15 +1963,16 @@
 
 def add_ui(ap, retry: int):
-    THEMES = 10
+    THEMES = 12
     ap2 = ap.add_argument_group("ui options")
     ap2.add_argument("--grid", action="store_true", help="show grid/thumbnails by default (volflag=grid)")
-    ap2.add_argument("--gsel", action="store_true", help="select files in grid by ctrl-click (volflag=gsel)")
+    ap2.add_argument("--bg-img", metavar="M,M,M", type=u, default="", help="URL to .jpg/png/gif/svg/webm/mp4/mkv/m4v/mov file to use as background, for example \033[32m/folder/image.jpg,opacity=0.5(optional),blur=5(optional)\033[0m supports relative paths. (volflag=bg_img)")
+    ap2.add_argument("--no-gsel", action="store_true", help="ctrl-click in gridview will open-in-new-tab instead of select-file (volflag=-gsel)")
     ap2.add_argument("--localtime", action="store_true", help="default to local timezone instead of UTC")
-    ap2.add_argument("--ui-filesz", metavar="FMT", type=u, default="1", help="default filesize format; one of these: 0, 1, 2, 2c, 3, 3c, 4, 4c, 5, 5c, 6, 6c, 7, 7c, fuzzy (see UI)")
+    ap2.add_argument("--ui-filesz", metavar="FMT", type=u, default="6", help="default filesize format; one of these: 0, 1, 2, 2c, 3, 3c, 4, 4c, 5, 5c, 6, 6c, 7, 7c, fuzzy (see UI)")
     ap2.add_argument("--gauto", metavar="PERCENT", type=int, default=0, help="switch to gridview if more than \033[33mPERCENT\033[0m of files are pics/vids; 0=disabled")
     ap2.add_argument("--rcm", metavar="TXT", default="yy", help="rightclick-menu; two yes/no options: 1st y/n is enable-custom-menu, 2nd y/n is enable-double")
     ap2.add_argument("--lang", metavar="LANG", type=u, default="eng", help="language, for example \033[32meng\033[0m / \033[32mnor\033[0m / ...")
     ap2.add_argument("--glang", action="store_true", help="guess the browser's default language, otherwise fall back to \033[33m--lang\033[0m")
-    ap2.add_argument("--theme", metavar="NUM", type=int, default=0, help="default theme to use (0..%d)" % (THEMES - 1,))
+    ap2.add_argument("--theme", metavar="NUM", type=int, default=0, help="default theme to use (0..%d) (volflag=theme)" % (THEMES - 1,))
     ap2.add_argument("--themes", metavar="NUM", type=int, default=THEMES, help="number of themes installed")
     ap2.add_argument("--au-vol", metavar="0-100", type=int, default=50, choices=range(0, 101), help="default audio/video volume percent")
@@ -1981,5 +1982,5 @@
     ap2.add_argument("--see-dots", action="store_true", help="default-enable seeing dotfiles; only takes effect if user has the necessary permissions")
     ap2.add_argument("--qdel", metavar="LVL", type=int, default=2, help="number of confirmations to show when deleting files (2/1/0)")
-    ap2.add_argument("--dlni", action="store_true", help="force download (don't show inline) when files are clicked (volflag:dlni)")
+    ap2.add_argument("--dlni", action="store_true", help="force download (don't show inline) when files are clicked (volflag=dlni)")
     ap2.add_argument("--unlist", metavar="REGEX", type=u, default="", help="don't show files/folders matching \033[33mREGEX\033[0m in file list. WARNING: Purely cosmetic! Does not affect API calls, just the browser. Example: [\033[32m\\.(js|css)$\033[0m] (volflag=unlist)")
     ap2.add_argument("--dothidden", action="store_true", help="hide specific files in a folder by listing them in a file named .hidden -- WARNING: Mostly cosmetic! Download-as-zip/tar will still download them. Do not rely on this for security (volflag=dothidden)")
@@ -2029,4 +2030,6 @@
     ap2.add_argument("--ui-norepl", action="store_true", help="hide repl-button in the UI (volflag=ui_norepl)")
     ap2.add_argument("--have-unlistc", action="store_true", help=argparse.SUPPRESS)
+    ap2.add_argument("--gsel", action="store_true", default=True, help=argparse.SUPPRESS)
+    ap2.add_argument("--unfun", action="store_true", help="hides many of the emojis in the UI")
 
 
diff -NarU2 a/copyparty/util.py b/copyparty/util.py
--- a/copyparty/util.py	2026-07-28 23:16:17.539485376 +0000
+++ b/copyparty/util.py	2026-07-28 23:14:14.885165997 +0000
@@ -471,5 +471,8 @@
 
 
-UNPLICATIONS = [["no_dav", "daw"]]
+UNPLICATIONS = [
+    ["no_dav", "daw"],
+    ["no_gsel", "gsel"],
+]
 
 
diff -NarU2 a/copyparty/web/baguettebox.js b/copyparty/web/baguettebox.js
--- a/copyparty/web/baguettebox.js	2026-07-08 15:13:32.819482011 +0000
+++ b/copyparty/web/baguettebox.js	2026-07-28 23:09:10.621788298 +0000
@@ -29,5 +29,5 @@
             readDirRtl: false,
         },
-        overlay, slider, btnPrev, btnNext, btnHelp, btnAnim, btnRotL, btnRotR, btnSel, btnFull, btnZoom, btnVmode, btnReadDir, btnGoPage, btnClose,
+        overlay, slider, btnPrev, btnNext, btnHelp, btnAnim, btnRotL, btnRotR, btnSel, btnFull, btnZoom, btnPixelated, btnVmode, btnReadDir, btnGoPage, btnClose,
         currentGallery = [],
         currentIndex = 0,
@@ -38,6 +38,6 @@
         scrollTimer = 0,
         re_i = APPLE ?
-            /^[^?]+\.(a?png|avif|bmp|gif|hei[cf]s?|jfif|jpe?g|jxl|svg|tiff?|webp)(\?|$)/i :
-            /^[^?]+\.(a?png|avif|bmp|gif|jfif|jpe?g|jxl|svg|tiff?|webp)(\?|$)/i,
+            /^[^?]+\.(a?png|avif|bmp|gif|hei[cf]s?|jfif|jpe?g|jxl|svg|ico|tiff?|webp)(\?|$)/i :
+            /^[^?]+\.(a?png|avif|bmp|gif|jfif|jpe?g|jxl|svg|ico|tiff?|webp)(\?|$)/i,
         re_v = /^[^?]+\.(webm|mkv|mp4|m4v|mov)(\?|$)/i,
         re_cbz = /^[^?]+\.(cbz)(\?|$)/i,
@@ -154,4 +154,7 @@
     }
 
+    var userAction = false;
+    function getUserAction(){return userAction}
+    function resetUserAction(){userAction = false}
     function bindImageClickListeners(selector, userOptions) {
         var galleryNodeList = QSA(selector);
@@ -185,4 +188,10 @@
 
                     e.preventDefault ? e.preventDefault() : e.returnValue = false;
+                    var newHash = '#g' + this.getAttribute('id') + getsort();
+                    if(location.hash != newHash){
+                        console.log("opened bbox manually");
+                        userAction = true;
+                        hist_push(newHash);
+                    }
                     prepareOverlay(gallery, userOptions);
                     showOverlay(imageIndex);
@@ -318,20 +327,21 @@
             var ctr = mknod('div');
             ctr.innerHTML = (
-                '<div id="bbox-overlay" role="dialog">' +
+                '<div id="bbox-overlay" class="normalrcm" role="dialog">' +
                 '<div id="bbox-slider"></div>' +
-                '<button id="bbox-prev" class="bbox-btn" type="button" aria-label="Previous">&lt;</button>' +
-                '<button id="bbox-next" class="bbox-btn" type="button" aria-label="Next">&gt;</button>' +
+                '<div id="bbox-prev"><a class="btn" aria-label="Previous">◀</a></div>' +
+                '<div id="bbox-next"><a class="btn" aria-label="Next">▶</a></div>' +
                 '<div id="bbox-btns">' +
-                '<button id="bbox-help" type="button">?</button>' +
-                '<button id="bbox-anim" type="button" tt="a">-</button>' +
-                '<button id="bbox-readdir" type="button" tt="a">ltr</button>' +
-                '<button id="bbox-rotl" type="button">↶</button>' +
-                '<button id="bbox-rotr" type="button">↷</button>' +
-                '<button id="bbox-tsel" type="button">sel</button>' +
-                '<button id="bbox-full" type="button" tt="full-screen">⛶</button>' +
-                '<button id="bbzoom" type="button" tt="zoom/stretch">z</button>' +
-                '<button id="bbox-vmode" type="button" tt="a"></button>' +
-                '<button id="bbox-gopage" type="button" tt="go to page">pg</button>' +
-                '<button id="bbox-close" type="button" aria-label="Close">X</button>' +
+                    '<a id="bbox-close" class="btn" aria-label="Close"><span class="x">×</span></a>' +
+                    '<a id="bbox-gopage" type="button" tt="go to page">pg</a>' +
+                    '<a id="bbox-vmode" class="btn" tt="a"></a>' +
+                    '<a id="bbox-full" class="btn" tt="full-screen">⛶</a>' +
+                    '<a id="bbzoom" class="tgl btn" tt="zoom/stretch smaller images to fill screen">↕</a>' +
+                    '<a id="bbpixelated" class="tgl btn" tt="pixelated rendering (good for pixel art)">👾</a>' +
+                    '<a id="bbox-tsel" class="tgl btn">☑️sel</a>' +
+                    '<a id="bbox-rotr" class="btn">↷</a>' +
+                    '<a id="bbox-rotl" class="btn">↶</a>' +
+                    '<a id="bbox-readdir" class="btn" tt="a">ltr</a>' +
+                    '<a id="bbox-anim" class="btn" tt="a">-</a>' +
+                    '<a id="bbox-help" class="btn">?</a>' +
                 '</div></div>'
             );
@@ -351,4 +361,5 @@
         btnFull = ebi('bbox-full');
         btnZoom = ebi('bbzoom');
+        btnPixelated = ebi('bbpixelated');
         btnVmode = ebi('bbox-vmode');
         btnGoPage = ebi('bbox-gopage');
@@ -357,4 +368,6 @@
         bcfg_bind(options, 'bbzoom', 'bbzoom', false, setzoom);
         setzoom();
+        bcfg_bind(options, 'bbpixelated', 'bbpixelated', false, setpixelated);
+        setpixelated();
     }
 
@@ -373,4 +386,5 @@
             ['F', 'toggle fullscreen'],
             ['Z', 'toggle zoom/stretch'],
+            ['X', 'toggle pixelated rendering'],
             ['S', 'toggle file selection'],
             ['G', 'cbz: go to page'],
@@ -458,4 +472,6 @@
         else if (kl == "z")
             btnZoom.click();
+        else if (kl == "x")
+            btnPixelated.click();
         else if (kl == "s")
             tglsel();
@@ -591,4 +607,10 @@
     }
 
+    function setpixelated() {
+        var sel = clgot(btnPixelated, 'on')
+        clmod(ebi('bbox-overlay'), 'pixelated', sel);
+        btnState(btnPixelated, sel);
+    }
+
     function tglsel() {
         var o = findfile()[3];
@@ -614,6 +636,5 @@
                 sel = true;
 
-        ebi('bbox-overlay').style.background = sel ?
-            'rgba(153,34,85,0.7)' : '';
+        clmod(ebi('bbox-overlay'), 'sel', sel);
 
         img.style.borderRadius = sel ? '1em' : '';
@@ -622,8 +643,5 @@
 
     function btnState(btn, sel) {
-        btn.style.color = sel ? '#fff' : '';
-        btn.style.background = sel ? '#d48' : '';
-        btn.style.textShadow = sel ? '1px 1px 0 #b38' : '';
-        btn.style.boxShadow = sel ? '.15em .15em 0 #502' : '';
+        clmod(btn, 'on', sel);
     }
 
@@ -772,8 +790,10 @@
             options.buttons = false;
 
-        btnPrev.style.display = btnNext.style.display = (options.buttons ? '' : 'none');
+        QS('#bbox-next .btn').style.display = QS('#bbox-prev .btn').style.display = (options.buttons ? '' : 'none');
     }
 
     function showOverlay(chosenImageIndex) {
+        clmod(ebi('wrap'), 'waiting', true);
+
         if (options.noScrollbars) {
             var a = document.documentElement.style.overflowY,
@@ -799,4 +819,5 @@
             preloadNext(currentIndex);
             preloadPrev(currentIndex);
+            clmod(ebi('wrap'), 'waiting', false);
         });
 
@@ -827,5 +848,4 @@
         ev(e);
         playvid(false);
-        removeFromCache('#files');
         if (options.noScrollbars) {
             document.documentElement.style.overflowY = scrollCSS[0];
@@ -849,5 +869,11 @@
             options.duringHide();
 
-        sethash('');
+        if(userAction){
+            console.log("closed bbox after manual open");
+            if(location.hash.startsWith('#gf-'))
+                history.back();
+        }
+        else
+            sethash('');
         unbindEvents();
 
@@ -1276,7 +1302,5 @@
 
     function show_buttons(v) {
-        clmod(ebi('bbox-btns'), 'off', v);
-        clmod(btnPrev, 'off', v);
-        clmod(btnNext, 'off', v);
+        clmod(ebi('bbox-overlay'), 'immersive', v);
     }
 
@@ -1340,9 +1364,9 @@
                 fx = x / (rc.right - rc.left);
 
-            if (fx < 0.3)
-                return showLeftImage();
+            // if (fx < 0.3)
+            //     return showLeftImage();
 
-            if (fx > 0.7)
-                return showRightImage();
+            // if (fx > 0.7)
+            //     return showRightImage();
 
             show_buttons('t');
@@ -1406,7 +1430,17 @@
         playpause: playpause,
         hide: hideOverlay,
-        destroy: destroyPlugin
+        destroy: destroyPlugin,
+        getUserAction: getUserAction,
+        resetUserAction: resetUserAction,
     };
 })();
 
+function bboxinit() {
+    if (msel && msel.bbox != true) {
+        timer.rm(bboxinit);
+        msel.bagit();
+    }
+}
+timer.add(bboxinit, true);
+
 J_BBX = 2;
diff -NarU2 a/copyparty/web/mde.js b/copyparty/web/mde.js
--- a/copyparty/web/mde.js	2026-07-08 15:13:32.822003171 +0000
+++ b/copyparty/web/mde.js	2026-05-22 21:41:25.295039355 +0000
@@ -10,5 +10,5 @@
     var n = location + '';
     n = (n.slice(n.indexOf('//') + 2).split('?')[0] + '?v').split('/');
-    n[0] = 'top';
+    n[0] = '🏠';
     var loc = [];
     var nav = [];
diff -NarU2 a/copyparty/web/md.js b/copyparty/web/md.js
--- a/copyparty/web/md.js	2026-07-08 15:13:32.822003171 +0000
+++ b/copyparty/web/md.js	2026-05-22 21:41:25.294836617 +0000
@@ -42,5 +42,5 @@
         o = mknod('a');
         o.setAttribute('href', link);
-        o.textContent = uricom_dec(parts[a].split('?')[0]) || 'top';
+        o.textContent = uricom_dec(parts[a].split('?')[0]) || '🏠';
         dom_nav.appendChild(o);
     }
diff -NarU2 a/copyparty/web/sw.js b/copyparty/web/sw.js
--- a/copyparty/web/sw.js	1970-01-01 00:00:00.000000000 +0000
+++ b/copyparty/web/sw.js	2026-07-08 15:11:40.610174059 +0000
@@ -0,0 +1,52 @@
+// service worker. required for PWAs
+// https://www.digitalapplied.com/blog/progressive-web-apps-2026-pwa-performance-guide
+// Register service worker on page load
+// modern syntax allowed here, only supported browsers load this file
+console.log('sw load')
+self.addEventListener("fetch", (event) => {
+    // Regular requests not related to Web Share Target.
+    var [baseurl, query] = event.request.url.split('?');
+    if (event.request.method !== "POST" || !query.match("share-target")) {
+        var toplevel = baseurl == self.location.origin;
+        if(query?.match("utm_source=launcher") && toplevel){
+            // prevent cors restriction
+            event.respondWith(
+                fetch(new Request("/", { mode: 'same-origin' }))
+            );
+            return;
+        }
+        console.log('normal response')
+        event.respondWith(fetch(event.request));
+        return;
+    }
+
+    // Requests related to Web Share Target.
+    event.respondWith(
+        (async () => {
+            try{
+                const formData = await event.request.formData();
+                const files = formData.getAll('files');
+
+                // store in cache for retrieval in up2k.js.
+                // leading "/" is necessary, because cache 
+                // operates relative to path of current file
+                const cache = await caches.open('/media');
+                for(var i = 0; i < files.length; i++){
+                    await cache.put('/shared-file-' + i, new Response(files[i]))
+                    await cache.put('/shared-filename-' + i, new Response(files[i].name))
+                }
+
+                await cache.put('/shared-file-count', new Response(files.length))
+
+                return Response.redirect('/?share-target', 303);
+            }
+            catch(e){
+                alert(e)
+            }
+        })(),
+    );
+});
+self.addEventListener('install', (event) => {
+    console.log('sw wait skip')
+    self.skipWaiting(); // insta replace old service workers (helpful for dev)
+});
\ No newline at end of file
